#!/usr/bin/perl -w
# Author        : Pedro Velho
# last modified : 08/02/2010
$thisdir= "/home/velho/public_html/personal/phd/07-speed/b-size/";

open(RAWOUTPUT, ">".$thisdir."/dat/"."raw.links.data") || die "Sorry, couldn't open file ".$thisdir."dat/raw.deploy.data for writting...\n";
        
print RAWOUTPUT " File FlowsDiff\n";
    
#ls -1 deploy
@files = `ls -1 $thisdir/deploy/`;

foreach (@files) { 
    chomp();
    $file = $_;

    my(@fields) = split(/-/, $file);
    $File = "platform/".$fields[0].".xml";
    $NFlows = $fields[3];

    if(!defined $NFlows){
	print "Missing experiment data skiping deployment '".$file."'...\n";
	next;
    }

    #print "Working on file $file\n";
    #print "file $File , flow $NFlows\n";

    open(DEPLOYMENT, "< $thisdir/deploy/$file") || die "Sorry couldn't open $file for reading\n";

    my %messages = ();
    reset(messages);

    $src="";
    $dst="";

    while(<DEPLOYMENT>){
	chomp();
	$line = $_;
	#print $line;

	if($line =~ m/.*<process.*/){
		
		$nodeName = $line;
		$nodeName =~ s/^.*host=.(.*).\s+function.*$/$1/;

		$proc = $line;
		$proc =~ s/^.*\s+function=.(.*)'>.*$/$1/;

	    if($proc eq "master"){
		$src = $nodeName;
	    }elsif ($proc eq "slave"){
		$dst = $nodeName;
		#print "Found message from $src to $dst\n";
		$$messages{$src}{$dst}++;
		#print "conter is $$messages{$src}{$dst}\n";
		$src = $dst = "";
	    }
	}
    }
    
    close(DEPLOYMENT);



    open(PLATFORM, "< ".$thisdir."/".$File) || die "Sorry, couldn't open file ".$thisdir."/".$File." for reading\n";

    $src = $dst = "";
    my %flowIn  = ();
    my %flowOut = ();

    while(<PLATFORM>){
	chomp();
	$line_plat = $_;

	if($line_plat =~ m/.*<route\s+src=\"(.*)\"\s+dst=\"(.*)\".*symetrical=\"NO\">(.*)<\/route>.*/){
	    $src = $1;
	    $dst = $2;
	    $line_parsed = $3;

	    #print "Found route from '$src' to '$dst'\n";
	    #print $line_parsed."\n";

	    if( $$messages{$src}{$dst} ){

		#print "Found route with messages from $src to $dst\n";
		my(@route_links) = split('/', $line_parsed);

		foreach $link (@route_links) {
		    
		    if($link =~ m/.*id=\"(.*)\".*direction=\"UP\".*/ ){
			$flowIn{$1}++;
			if( !$flowOut{$1} ){
			    $flowOut{$1} = 0;
			}
		    }elsif($link =~ m/.*id=\"(.*)\".*direction=\"DOWN\".*/ ){
			$flowOut{$1}++;
			if( !$flowIn{$1} ){
			    $flowIn{$1} = 0;
			}
		    } 
		    #print "Link:$1 $flowIn{$1} $flowOut{$1}\n";		    
		}
	    }
	}
    }
    close(PLATFORM);
    
    #print "=====>Printing the keys for file $file====>\n";

    $result = 0;
    foreach  my $key ( keys %flowIn ){
	if($result < abs($flowIn{$key}-$flowOut{$key})){
	    $result = abs($flowIn{$key}-$flowOut{$key});
	}
    }

    print $NFlows." ".$File." ".$result."\n";	    	

#    exit;
}

close(RAWOUTPUT);
