#!/usr/bin/perl -w
# Author        : Pedro Velho
# last modified : 08/02/2010

sub sum {
    my(@arr) = @_;
    my($sum_res) = 0;

    foreach $elem (@arr) {
	$sum_res += $elem;
    }

    return $sum_res;
}

if(scalar(@ARGV) != 2){
    print "Usage:\n\tmod-platform.pl <input_file> <stat|exec>\n\n";
    print "\texec will divide latency and bandwidth by 10 in 20\% of nodes.\n";
    print "\tstat will print platform resumed information.\n";
    exit 1;
} 

open(INPUTPLAT, " < ".$ARGV[0]) || die "Could not open file ".$ARGV[0]." for reading";


my(@bw_array)  = ();
my(@lat_array) = ();
my($stat);


if($ARGV[1] =~ m/^exec$/ ){
    $stat = 0;
}elsif($ARGV[1] =~ m/^stat$/ ){
    $stat = 1;
}else{
    die "Invalid third parameter must be 'exec' or 'stat'.\n";
}


my($nhost)=0;
my($nrouter)=0;


while(<INPUTPLAT>){
    chomp();

    $line = $_;

    if($line =~ m/(.*bandwidth\D*)(\d+.\d+([eE][+-]?\d+)?)(\D*latency\D*)(\d+.\d+([eE]?[+-]?\d+)?)(\D*.*)/){

	$bw=$2;
	$lat=$5;

	push @bw_array, $bw; 
	push @lat_array, $lat;

	if(scalar($stat) == 0){
	    if( rand() < 0.2 ){
		print $1.($bw/10).$4.($lat/10).$7."\n";
	    }else{
		print $1.($bw).$4.($lat).$7."\n";	    
	    }
	}
	next;
    }

    if($line =~ m/.*<host.*/){
	$nhost++;
	next;
    }

    if($line =~ m/.*<router.*/){
	$nrouter++;
	next;
    }

    if(scalar($stat) == 0){	
	print $_,"\n";
    }
}


if($stat){	
    print "Hosts  : ".$nhost."\n";
    print "Router : ".$nrouter."\n";

    @lat_array = sort { $a <=> $b } @lat_array;
    
    $last_elem = scalar(@lat_array) - 1;

   print " === Stats latency analyzis ===\n";
   print " MEAN  : ".sum( @lat_array)/scalar(@lat_array)."\n";
   print " RANGE : [".$lat_array[0].";".$lat_array[$last_elem]."]\n";
   print " MEDIAN: ".($lat_array[$last_elem]/2)."\n";


    

#    print $ARGV[0]." & WAX/TIERs & ".($nhost)." & ".($nrouter)." & ".(scalar(@lat_array))." & ".sprintf("%.6f", $lat_array[0])." & ".sprintf("%.4f", ($lat_array[$last_elem]/2))." & ".sprintf("%.4f",$lat_array[$last_elem])." ";


    @bw_array = sort { $a <=> $b } @bw_array;
    
    $last_elem = scalar(@bw_array) - 1;

   print " === Stats bandwidth analyzis ===\n";
   print " MEAN  : ".sum( @bw_array)/scalar(@bw_array)."\n";
   print " RANGE : [".$bw_array[0].";".$bw_array[$last_elem]."]\n";
   print " MEDIAN: ".($bw_array[$last_elem]/2)."\n";

    # print " & ".sprintf("%.f",($bw_array[0])/1000)." & ".sprintf("%.f",($bw_array[$last_elem]/2)/1000)." & ".sprintf("%.f",$bw_array[$last_elem]/1000)." \\\\ \n ";

}



