#!/usr/bin/perl -w
# Author        : Pedro Velho
# last modified : 08/02/2010

sub sum {
    my(@arr) = @_;
    my($sum_res) = 0;

    foreach $elem (@arr) {
	$sum_res += $elem;
    }

    return $sum_res;
}

if(scalar(@ARGV) != 1){
    print "Usage:\n\tconvert_fullduplex_platform.pl <input_file>\n\n";
    exit 1;
} 

open(INPUTPLAT, " < ".$ARGV[0]) || die "Could not open file ".$ARGV[0]." for reading";

my(@bw_array)  = ();
my(@lat_array) = ();
my($stat);

my($nhost)=0;
my($nrouter)=0;

while(<INPUTPLAT>){
    chomp();

    $line = $_;

    if($line =~ m/(<route src=\".*\" dst=\".*\")>(<link.ctn.*)(<\/route>).*/){
	# Change link:ctn to link_ctn and add the direction needed by fullduplex 
	$pre = $1;
	$link_list = $2;
	$pos = $3;

	print $pre." symetrical=\"NO\">";
	foreach (split(/>/,$link_list)) {
	    if($_ =~ m/.*id=\"([0-9]+)\_([0-9]+)\".*/ ) {
		if($1 < $2){
		    $link_name = $1.$2;
		    $direction = "UP";
		}else {
		    $link_name = $2.$1;
		    $direction = "DOWN";
		}
		print "<link_ctn id=\"".$link_name."\" direction=\"".$direction."\"/>";
	    }
	}	
	print $pos."\n";

    }elsif($line =~ m/\s+(<link\s+id=\")(.*)(\"\s+bandwidth=.*)\/>.*/){
	# Simplify link names and use right sharing policy 
	$pre = $1;
	$pos = $3;
	$link_name = $2;
	$link_name =~ m/([0-9]+)\_([0-9]+)/;
	$link_name = ($1 < $2)?$1.$2:$2.$1;
	#print $line."\n"; 
	if(!$link_list{$link_name}){
	    print "".$pre.$link_name.$pos." sharing_policy=\"FULLDUPLEX\" \/>\n";
	    $link_list{$link_name} = 1;
	}
    }elsif($line =~ m/.*<platform.*/){
	# ADD the Autonomous System (AS) TAG 
	print $line."\n";
	print "<AS id=\"AS0\" routing=\"Full\">\n";

    }elsif($line =~ m/.*<\/platform>.*/){
	# End the Autonomous System (AS) TAG 
	print "</AS>\n";
	print $line."\n";

    }else{
	print $line."\n";
    }
}


